import { Macroable } from 'macroable';
import type { Arrayable, Nullable } from '@stacksjs/types';
import type { PartitionFilter } from './helpers';
export declare class Arr extends Macroable {
    contains(needle: string, haystack: string[]): boolean;
    containsAll(needles: string[], haystack: string[]): boolean;
    containsAny(needles: string[], haystack: string[]): boolean;
    containsNone(needles: string[], haystack: string[]): boolean;
    containsOnly(needles: string[], haystack: string[]): boolean;
    doesNotContain(needle: string, haystack: string[]): boolean;
    toArray<T>(array?: Nullable<Arrayable<T>>): Array<T>;
    flatten<T>(array?: Nullable<Arrayable<T | Array<T>>>): Array<T>;
    mergeArrayable<T>(...args: Nullable<Arrayable<T>>[]): Array<T>;
    partition<T>(array: readonly T[], filter: PartitionFilter<T>): [T[], T[]];
    /**
     * Returns a random item/s from the array
     */
    random<T>(arr: T[], count?: number): T[];
    /**
     * Returns random item/s from the array
     */
    sample<T>(arr: T[], count?: number): T[];
    unique<T>(arr: T[]): T[];
    uniqueBy<T>(arr: readonly T[], equalFn: (a: any, b: any) => boolean): T[];
    last<T>(arr: T[]): T | undefined;
    remove<T>(arr: T[], value: T): boolean;
    at(arr: any[], index: number): any;
    range(start: number, end: number, step?: number): number[];
    move<T>(arr: T[], from: number, to: number): T[];
    clampArrayRange(arr: readonly unknown[], n: number): number;
    shuffle<T>(arr: T[]): T[];
    /**
     * Returns the sum of all items in the array
     */
    sum(arr: number[]): number;
    /**
     * Returns the average of all items in the array
     */
    average(arr: number[]): number;
    avg(arr: number[]): number;
    /**
     * Returns the median of all items in the array
     */
    median(arr: number[]): number;
    /**
     * Returns the mode of all items in the array
     */
    mode(arr: number[]): number;
    static macros: {};
    static getters: {};
}
export declare const arr: Arr;
